*** req.c.org	Thu Jun 22 08:37:41 2000
--- req.c	Thu Jun 22 09:04:23 2000
***************
*** 151,156 ****
--- 151,157 ----
  	BIO *in=NULL,*out=NULL;
  	int informat,outformat,verify=0,noout=0,text=0,keyform=FORMAT_PEM;
  	int nodes=0,kludge=0,newhdr=0;
+ 	char *inrand=NULL;
  	char *infile,*outfile,*prog,*keyfile=NULL,*template=NULL,*keyout=NULL;
  	char *extensions = NULL;
  	char *req_exts = NULL;
***************
*** 345,350 ****
--- 346,356 ----
  			if (--argc < 1) goto bad;
  			req_exts = *(++argv);
  			}
+ 		else if (strcmp(*argv,"-rand") == 0)
+ 			{
+ 			if (--argc < 1) goto bad;
+                         inrand= *(++argv);
+ 			}
  		else
  			{
  			BIO_printf(bio_err,"unknown option %s\n",*argv);
***************
*** 542,549 ****
  
  	if (newreq && (pkey == NULL))
  		{
! 		char *randfile = CONF_get_string(req_conf,SECTION,"RANDFILE");
! 		app_RAND_load_file(randfile, bio_err, 0);
  	
  		if (newkey <= 0)
  			{
--- 548,560 ----
  
  	if (newreq && (pkey == NULL))
  		{
! 		if (!app_RAND_load_file(NULL, bio_err, 1) && inrand == NULL)
!                 	{
!                 	BIO_printf(bio_err,"warning, not much extra random data, consider using the -rand option\n");
!                 	}
!         	if (inrand != NULL)
!                 	BIO_printf(bio_err,"%ld semi-random bytes loaded\n",
!                         	app_RAND_load_files(inrand));
  	
  		if (newkey <= 0)
  			{
***************
*** 582,588 ****
  			}
  #endif
  
! 		app_RAND_write_file(randfile, bio_err);
  
  		if (pkey == NULL) goto end;
  
--- 593,599 ----
  			}
  #endif
  
! 		app_RAND_write_file(NULL, bio_err);
  
  		if (pkey == NULL) goto end;
  
